from typing import Any, Dict, List, Type, TypeVar, Union

import attr

from ..types import UNSET, Unset

T = TypeVar("T", bound="DeleteLockRequest")


@attr.s(auto_attribs=True)
class DeleteLockRequest:
    """
    Attributes:
        pair (Union[Unset, str]):
        lockid (Union[Unset, int]):
    """

    pair: Union[Unset, str] = UNSET
    lockid: Union[Unset, int] = UNSET
    additional_properties: Dict[str, Any] = attr.ib(init=False, factory=dict)

    def to_dict(self) -> Dict[str, Any]:
        pair = self.pair
        lockid = self.lockid

        field_dict: Dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({})
        if pair is not UNSET:
            field_dict["pair"] = pair
        if lockid is not UNSET:
            field_dict["lockid"] = lockid

        return field_dict

    @classmethod
    def from_dict(cls: Type[T], src_dict: Dict[str, Any]) -> T:
        d = src_dict.copy()
        pair = d.pop("pair", UNSET)

        lockid = d.pop("lockid", UNSET)

        delete_lock_request = cls(
            pair=pair,
            lockid=lockid,
        )

        delete_lock_request.additional_properties = d
        return delete_lock_request

    @property
    def additional_keys(self) -> List[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
